angular.module('flashy.FeedController',
    ['ui.router',
        'ngAnimate',
        'ngWebSocket',
        'contenteditable',
        'flashy.DeckFactory']).controller('FeedController',
    function($scope, $rootScope, $state, $http, $window, $timeout, $stateParams, $websocket, $interval, UserService, Flashcard, Deck) {
        angular.module('flashy.CardGridController').CardGridController.apply(this, arguments);
        var promise;
        sectionId = parseInt($stateParams.sectionId);
        $scope.updateCardScore = function(card, scoreChange) {
            console.log('update card score');
            // if no colNum is attached, then this doesn't exist on the feed yet
            if (typeof card.colNum === 'undefined' || typeof card.colRank === 'undefined') {
                console.log('no col num');
                return;
            }
            /*$scope.cardCols[card.colNum].sort(function(a, b) {
             return b.score - a.score;
             });
             console.log($scope.cardCols);
             $scope.updateColRanks($scope.cardCols[card.colNum]);
             return;*/
            console.log(card.score);
            card.score += scoreChange;
            console.log(card.score);
            var col = card.colNum;
            var rank = card.colRank;
            var s = Math.sign(scoreChange);

            //rank -= s;
            if (rank < 0) return;
            if (rank == $scope.cardCols[col].length) return;

            $scope.affectedCards = [];
            //console.log('before whiel, rank:' + rank);
            if (s > 0) {
                rank -= 1;
                //console.log('+');
                while ($scope.cardCols[col][rank].score < card.score) {
                    //console.log('while');
                    $scope.cardCols[col][rank].colRank += 1;
                    $scope.affectedCards.push($scope.cardCols[col][rank]);
                    rank -= 1;
                    if (rank < 0) break;
                    if (rank == $scope.cardCols[col].length) break;
                }
            } else {
                rank += 1;
                console.log('-');
                while ($scope.cardCols[col][rank].score > card.score) {
                    //console.log('while');
                    $scope.cardCols[col][rank].colRank -= 1;
                    $scope.affectedCards.push($scope.cardCols[col][rank]);
                    rank += 1;
                    if (rank < 0) break;
                    if (rank == $scope.cardCols[col].length) break;
                }
            }
            rank += s;
            //console.log('after a whiel, rank:' + rank);

            console.log($scope.affectedCards);

            var upMove = $scope.height;
            var downMove = $scope.height;
            $scope.$apply(function() {
                $('.card.flashy.card-moveUp').css({
                    'margin-top': 300 + 'px !important', // how much moveUp moves
                });

                $('.card.flashy.card-moveDown').css({
                    'margin-top': 300 + 'px !important', // how much moveDown moves
                });
            });

            if (s > 0) {
                card.moveUp = true;
                upMove *= $scope.affectedCards.length;
                /*for (i=0; i<$scope.affectedCards.length; i++) {
                 $scope.affectedCards[i].moveDown = true;
                 }*/
            } else {
                card.moveDown = true;
                downMove *= $scope.affectedCards;
                /*for (i=0; i<$scope.affectedCards.length; i++) {
                 $scope.affectedCards[i].moveUp = true;
                 }*/
            }

            $timeout(function() {
                $('.card.flashy.card-moveUp').css({
                    'margin-top': '6px',
                });

                $('.card.flashy.card-moveDown').css({
                    'margin-top': '6px',
                });
                if (s > 0) {
                    card.moveUp = false;
                    for (i = 0; i < $scope.affectedCards.length; i++) {
                        $scope.affectedCards[i].moveDown = false;
                    }
                } else {
                    card.moveDown = false;
                    for (i = 0; i < $scope.affectedCards.length; i++) {
                        $scope.affectedCards[i].moveUp = false;
                    }
                }
            }, 1000);
            $scope.cardCols[col].splice(rank, 0, $scope.cardCols[col].splice(card.colRank, 1)[0]);
            card.colRank = rank;
            //$scope.updateColRanks($scope.cardCols[card.colNum]); // can be optimized out
        };

        $scope.feed_ws = $websocket($scope.ws_host + '/ws/feed/' + sectionId + '?subscribe-broadcast');
        $scope.feed_ws.onMessage(function(e) {
            data = JSON.parse(e.data);
            console.log(data.event_type, 'message', data.flashcard);
            if (data.event_type == 'new_card') {
                // don't trust the backend for feed's authored_by_user
                card = data.flashcard;
                delete card['is_authored_by_user'];
                card = new Flashcard(card);
                $scope.addCardToGrid(card, $scope.deck);
            } else if (data.event_type == 'score_change') {
                card = new Flashcard(data.flashcard); // doesnt create a card if it exists
                //card.score = data.flashcard.score;
                console.log('score change');
                $scope.updateCardScore(card, data.flashcard.score - card.score);
            }
        });

        $scope.pushCard = function() {
            var myCard = {
                // we can't trim this string because it'd mess up the blanks. Something to fix.
                'text': $('#new-card-input').text(),
                'mask': $scope.newCardBlanks,
                section: $scope.section.id
            };
            if (!$scope.submit_enabled) {
                return;
            }
            if (myCard.text == '') {
                console.log('blank flashcard not pushed:' + myCard.text);
                return closeNewCard();
            }
            $http.post('/api/flashcards/', myCard).
                success(function(data) {
                    console.log('flashcard pushed: ' + myCard.text);
                    if (!UserService.hasVerifiedEmail()) {
                        Materialize.toast("<p>Thanks for contributing! However, others won't see your card until you verify your email address<p>", 4000);
                    }
                });
            return $scope.closeNewCardModal();
        };

        /* Key bindings for the whole feed window. Hotkey it up! */
        var listenForC = true;

        // Need to pass these options into openmodal and leanmodal,
        // otherwise the ready handler doesn't get called

        modal_options = {
            dismissible: true, // Modal can be dismissed by clicking outside of the modal
            opacity: 0, // Opacity of modal background
            in_duration: 300, // Transition in duration
            out_duration: 200, // Transition out duration
            ready: function() {
                $('#new-card-input').focus();
                document.execCommand('selectAll', false, null);
            }
        };

        $(document).keydown(function(e) {
            var keyed = e.which;
            if (keyed == 67 && listenForC) { // "c" for compose
                if ($scope.currentEditingCard) return;
                $scope.openNewCardModal();
                e.preventDefault();
                return false;
            } else if (keyed == 27) { // clear on ESC
                $scope.closeNewCardModal();
                $scope.discardEditChanges();
            }
        });

        $scope.openNewCardModal = function() {
            $('#newCard').openModal(modal_options);
            listenForC = false;
            $('#new-card-input').html('Write a flashcard!');
        };

        $scope.closeNewCardModal = function() {
            listenForC = true;
            $('#new-card-input').html('').blur();
            $('#newCard').closeModal(modal_options);
        };

        $('.tooltipped').tooltip({delay: 50});
        // the "href" attribute of .modal-trigger must specify the modal ID that wants to be triggered
        $('.modal-trigger').leanModal(modal_options);

        $('#new-card-input').on('keydown', function(e) {
            if (e.which == 13) {
                e.preventDefault();
                if ($scope.submit_enabled) {
                    $scope.pushCard();
                }
                return false;
            }
        });


        $scope.newCardBlanks = [];
        $scope.refreshNewCardInput = function() {
            $scope.newCardText = $('#new-card-input').text();
            $scope.submit_enabled = $scope.newCardText.length >= 5 && $scope.newCardText.length <= 160;
            var i = 0;
            $scope.newCardBlanks = [];
            $('#new-card-input')[0].childNodes.forEach(function(node) {
                node = $(node)[0];
                if (node.tagName == 'B') {
                    var text = $(node).text();
                    var leftspaces = 0, rightspaces = 0;
                    // awful way to find the first non-space character from the left or the right. thanks.js
                    while (text[leftspaces] == ' ' || text[leftspaces] == '\xa0') leftspaces++;
                    while (text[text.length - 1 - rightspaces] == ' ' || text[text.length - 1 - rightspaces] == '\xa0') rightspaces++;
                    console.log(leftspaces, text.length);
                    if (leftspaces != text.length) $scope.newCardBlanks.push([i + leftspaces, i + text.length - rightspaces]);
                    i += text.length;
                } else if (!node.data) {
                    i += $(node).text().length;
                } else {
                    i += node.data.length;
                }
            });
            $scope.newCardBlanks.sort(function(a, b) {
                return a[0] - b[0];
            });
            i = 0;
            newtext = '';
            $scope.newCardBlanks.forEach(function(blank) {
                newtext += $scope.newCardText.slice(i, blank[0]);
                newtext += '<b>' + $scope.newCardText.slice(blank[0], blank[1]) + '</b>';
                i = blank[1];
            });
            newtext += $scope.newCardText.slice(i);
            //$scope.newCardFormattedText = newtext;
        };
        $scope.shuffleCards = function() {
            $timeout(function() {
                (function(o) {
                    for (var j, x, i = o.length; i; j = Math.floor(Math.random() * i), x = o[--i], o[i] = o[j], o[j] = x);
                    return o;
                })($scope.cardCols[0]);
            });
        };
        $scope.$on('$destroy', function() {
            $scope.feed_ws.close();
            $interval.cancel(promise);
        });
        return $http.get('/api/sections/' + sectionId + '/feed/').
            success(function(data) {
                console.log(data);
                $scope.cards = data.map(function(card) {
                    return new Flashcard(card, $scope.deck);
                });
                $scope.refreshLayout();
                $timeout($scope.refreshColumnWidth).then(function() {
                    $scope.showGrid = true;
                });
                console.log('layout done');
            });

    });
