angular.module('flashy.HelpController', ['ui.router']).

    controller('HelpController', function($scope, $state, $http, $timeout) {
        $scope.toggleContent = function(event, index) {
            console.log(event, index);

            if ($('#content-' + index).hasClass('open')) { // let's close it
                // Note: 250 is duration (ms) of animation
                $('#content-' + index).slideUp(250).removeClass('open');
            } else { // let'd open it
                $('#content-' + index).slideDown(250).addClass('open');
            }

//            event.currentTarget
        };

        $scope.closeContent = function(event) {

        };

        // JSON OF FAQ ENTRIES
        $scope.entries = [
            {
                // icon: 'mdi-editor-insert-emoticon small',
                question: 'What is Flashy?',
                answer: '<p>Flashy is a service for creating, sharing, and reviewing flashcards for your courses.' +
                '</p><p>Flashy is optimized for contributing cards in real time during lecture to a shared live' +
                " feed. Don't want to contribute cards? That's fine! By adding others' cards to your deck, you" +
                ' help identify high-quality cards which should remain at the top of the feed for others to choose.' +
                '</p><p>Based on the principles of spaced repetition, Flashy also intelligently determines which' +
                ' cards you are most at risk of forgetting, based on your review history. Receive push ' +
                "notifications on your Android device's Chrome browser without installing any other app," +
                " and we'll notify you when you have a few cards which need to be reviewed.</p>"
            },
            {
                // icon: 'mdi-file-cloud-queue small',
                question: 'Does Flashy work outside of UCSD?',
                answer: "To simplify development, Flashy was configured only for courses at UCSD. If you'd like Flashy for your school, please send us an email to let us know!"
            },
            {
                // icon: 'mdi-hardware-security small',
                question: 'How do registration and verification work?',
                answer: "An account is required to use Flashy. We store the cards you save to your deck with your account. When you register, you'll be able to use the site immediately, but you must verify ownership of your email address within 24 hours. After 24 hours have passed, you'll need to verify your address before continuing to use the site. Don't worry, your cards and deck won't be deleted."
            },
            {
                question: "My question isn't answered above",
                answer: '<a href="mailto:or.so.help.me@flashy.cards">Send us an email</a> or join us on Freenode in <a href="irc://irc.freenode.net/flashy">#flashy</a>!'
            }];

        // Functions
        $scope.toggleContent = function(event, index) {
            if ($('#content-' + index).hasClass('open')) { // let's close it
                // Note: 250 is duration (ms) of animation
                $('#content-' + index).slideUp(250).removeClass('open');
            } else { // let's open it
                $('#content-' + index).slideDown(250).addClass('open');
            }
        };

        $scope.expandAllContent = function() {
            for (var i = 0; i < $scope.entries.length; i++) {
                $('#content-' + i).slideDown(0).addClass('open');
            }
        };

        $scope.collapseAllContent = function() {
            for (var i = 0; i < $scope.entries.length; i++) {
                $('#content-' + i).slideUp(0).removeClass('open');
            }
        };
    });
