angular.module('flashy.LoginController', ['ui.router']).

    controller('LoginController', ['$rootScope', '$scope', '$state', '$http', 'UserService',
        function($rootScope, $scope, $state, $http, UserService) {
            'use strict';
            // If we're logged in, there's nothing to do here

            if (UserService.isLoggedIn()) {
                console.log('logged in already');
                UserService.redirectToDefaultState($state);
            }
            $scope.uniqueError = false;
            $scope.loginError = false;
            $scope.login = function(email, password) {
                $http.post('/api/login/', JSON.stringify({
                    'email': email,
                    'password': password
                })).
                    success(function(data) {
                        UserService.login(data);
                        if (angular.isDefined($scope.returnToState))
                            $state.go($scope.returnToState.name, $scope.returnToStateParams);
                        else
                            UserService.redirectToDefaultState($state);
                    }).
                    error(function(data, status, header, config) {
                        if (data.detail) { // assume 'invalid email or pass'
                            $scope.loginError = true;
                            $scope.loginPassword = '';
                        }
                        console.log(data);
                    });
            };
            $scope.signUp = function(email, password) {
                $http.post('/api/register/', JSON.stringify({
                    'email': email,
                    'password': password
                })).
                    success(function(data) {
                        UserService.login(data);
                        if (angular.isDefined($scope.returnToState))
                            $state.go($scope.returnToState.name, $scope.returnToStateParams);
                        else $state.go('addclass');

                    }).
                    error(function(data, status, headers, config) {
                        console.log('signup error', data);
                        if (data.email == 'This field is required.') {
                            $scope.invalid = true;
                            $scope.uniqueError = false;
                        } else if (data.email == 'This field must be unique.') {
                            // assume 'email not unique' error
                            $scope.uniqueError = true;
                            $scope.invalid = false;
                        }
                        if (data.password == 'Ensure this field has at least 8 characters.')
                            $scope.passwordError = 'Password must be at least 8 characters in length.';
                        console.log(data);
                    });

            };
            $scope.triggerPasswordReset = function() {
                $state.go('requestpasswordreset');
            };
            $(document).ready(function() {
                $('ul.tabs').tabs();
            });
        }
    ]);
