angular.module('flashy.ResetPasswordController', ['ui.router']).

    controller('ResetPasswordController', function($scope, $state, $stateParams, $http, UserService) {
        $scope.error = false;
        $scope.success = false;
        $scope.mismatch = false;
        $scope.unacceptable = false;

        $scope.confirmResetPass = function() {
            if ($scope.newPassword.length < 8) {
                $scope.unacceptable = true;
                return;
            }
            if ($scope.newPassword != $scope.confirmPassword) {
                $scope.mismatch = true;
                $scope.confirmPassword.$setPristine();
                console.log('mismatch');
                return;
            }
            /*password passes local tests*/
            $http.post('/api/reset_password/', JSON.stringify({
                'uid': $stateParams.uid,
                'token': $stateParams.token,
                'new_password': $scope.newPassword
            }))
                .success(function(data) {
                    $scope.error = false;
                    $scope.success = true;
                    UserService.startAuth().then(function() {
                        $state.go('login');
                    });
                    Materialize.toast('Your password was successfully changed', 4000);
                })
                .error(function(data, status, header, config) {
                    $scope.error = true;
                    $scope.success = false;
                    $scope.mismatch = false;
                    $scope.unacceptable = false;
                    console.log(data);
                });
        };
        $scope.cancelReset = function() {
            $state.go('login');
        };
    });
