angular.module('flashy.SettingsController', ['ui.router']).

    controller('SettingsController', function($rootScope, $resource, $scope, $state, $http, UserService) {
        $scope.error = false;
        $scope.success = false;
        $scope.mismatch = false;
        $scope.unacceptable = false;


        $scope.changePassword = function(oldPassword, newPassword, confirmedNewPassword) {
            console.log('in change password');

            if ($scope.ChangePasswordForm.newpw.$error.minlength == true) {
                $scope.unacceptable = true;
                console.log('unacceptable password');
                return;
            }

            if (newPassword != confirmedNewPassword) {
                $scope.mismatch = true;
                console.log('mismatch');
                return;
            } else {

                $scope.mismatch = false;

            }


            $http.patch('/api/me/', {
                'old_password': oldPassword,
                'new_password': newPassword
            })
                .success(function(data) {
                    console.log('password successfully changes');
                    Materialize.toast('Your password was successfully changed', 3000);
                    $state.go('login');

                })
                .error(function(data) {
                    console.log('problem changing the password');
                    Materialize.toast('Your old password is not correct', 3000);
                });
        };

        $scope.dropClass = function(section) {
            $http.post('/api/sections/' + section.id + '/drop/').
                success(function(data) {
                    UserService.dropClass(section.id);
                    console.log(section.short_name + ' dropped');
                    Materialize.toast('Dropped', 3000);
                });
        };


        console.log('checking to see if chrome');

        if (typeof(chrome) === 'undefined') {
            //pushSwitch.disabled = true;
            return;
        }

        console.log('chrome');

        console.log('executing things outside of module');
        var PUSH_SERVER_URL = '/api/subscribe/';
        var UNPUSH_SERVER_URL = '/api/unsubscribe/';

        function onPushSubscription(pushSubscription) {
            console.log('pushSubscription = ', pushSubscription.endpoint);
            // Here we would normally send the endpoint
            // and subscription ID to our server.
            // In this demo we just use send these values to
            // our server via XHR which sends a push message.

            var endpoint = pushSubscription.endpoint;
            var subscriptionId = pushSubscription.subscriptionId;

            console.log('registration_id: ', subscriptionId);
            $http.post(PUSH_SERVER_URL, {'registration_id': subscriptionId});
        }

        function removeSubscription(pushSubscription) {
            console.log('removing subscription');
            console.log('pushSubscription endpoint = ', pushSubscription.endpoint);

            var subscriptionId = pushSubscription.subscriptionId;

            console.log('registration_id: ', subscriptionId);
            $http.post(UNPUSH_SERVER_URL, {'registration_id': subscriptionId});
        }

        function subscribeDevice() {
            // We need the service worker registration to access the push manager
            navigator.serviceWorker.ready.then(function(serviceWorkerRegistration) {
                serviceWorkerRegistration.pushManager.subscribe()
                    .then(onPushSubscription)
                    .catch(function(e) {
                        console.log('Error in subscribing');
                        // Check for a permission prompt issue
                        if ('permissions' in navigator) {
                            navigator.permissions.query({name: 'push', userVisibleOnly: true})
                                .then(function(permissionStatus) {
                                    console.log('subscribe() Error: Push permission status = ',
                                        permissionStatus);
                                    if (permissionStatus.status === 'denied') {
                                        pushSwitch.checked = false;
                                        pushSwitch.disabled = true;
                                        // The user blocked the permission prompt
                                        console.log('Ooops Notifications are Blocked',
                                            'Unfortunately you just permanently blocked notifications. ' +
                                            'Please unblock / allow them to switch on push ' +
                                            'notifications.');
                                    } else {
                                        pushSwitch.checked = false;
                                        console.log('Ooops Push Couldn\'t Register',
                                            '<p>When we tried to ' +
                                            'get the subscription ID for GCM, something went wrong,' +
                                            ' not sure why.</p>' +
                                            '<p>Have you defined "gcm_sender_id" and ' +
                                            '"gcm_user_visible_only" in the manifest?</p>' +
                                            '<p>Error message: ' +
                                            e.message +
                                            '</p>');
                                    }
                                }).catch(function(err) {
                                    pushSwitch.checked = false;
                                    console.log('Ooops Push Couldn\'t Register',
                                        '<p>When we tried to ' +
                                        'get the subscription ID for GCM, something went wrong, not ' +
                                        'sure why.</p>' +
                                        '<p>Have you defined "gcm_sender_id" and ' +
                                        '"gcm_user_visible_only" in the manifest?</p>' +
                                        '<p>Error message: ' +
                                        err.message +
                                        '</p>');
                                });
                        } else {
                            // Use notification permission to do something
                            if (Notification.permission === 'denied') {
                                pushSwitch.disabled = true;
                                pushSwitch.checked = false;
                                console.log('Ooops Notifications are Blocked',
                                    'Unfortunately you just permanently blocked notifications. ' +
                                    'Please unblock / allow them to switch on push notifications.');
                            } else {
                                pushSwitch.checked = false;
                                console.log('Ooops Push Couldn\'t Register',
                                    '<p>When we tried to ' +
                                    'get the subscription ID for GCM, something went wrong, not ' +
                                    'sure why.</p>' +
                                    '<p>Have you defined "gcm_sender_id" and ' +
                                    '"gcm_user_visible_only" in the manifest?</p>' +
                                    '<p>Error message: ' +
                                    e.message +
                                    '</p>');
                            }
                        }
                    });
            });
        }

        function unsubscribeDevice() {
            navigator.serviceWorker.ready.then(function(serviceWorkerRegistration) {
                serviceWorkerRegistration.pushManager.getSubscription().then(
                    function(pushSubscription) {
                        // Check we have everything we need to unsubscribe
                        if (!pushSubscription) {
                            pushSwitch.checked = false;
                            return;
                        }

                        // TODO: Remove the device details from the server
                        // i.e. the pushSubscription.subscriptionId and
                        // pushSubscription.endpoint
                        var subscriptionId = pushSubscription.subscriptionId;

                        pushSubscription.unsubscribe().then(function(successful) {
                            console.log('Unsubscribed from push: ', successful);

                            if (!successful) {
                                // The unsubscribe was unsuccessful, but we can
                                // remove the subscriptionId from our server
                                // and notifications will stop
                                // This just may be in a bad state when the user returns
                                pushSwitch.checked = true;
                                console.error('We were unable to unregister from push, but we removed' +
                                    'registration id from the server');
                            }
                            removeSubscription(pushSubscription);

                        }).catch(function(e) {
                            console.log('Unsubscribtion error: ', e);
                        });
                    }.bind(this)).catch(function(e) {
                        console.error('Error thrown while revoking push notifications. ' +
                            'Most likely because push was never registered', e);
                    });
            });
        }

        function permissionStatusChange(permissionStatus) {
            console.log('permissionStatusChange = ', permissionStatus);
            // If the notification permission is denied, it's a permanent block
            switch (permissionStatus.status) {
                case 'denied':
                    pushSwitch.disabled = true;
                    console.log('Ooops Push has been Blocked',
                        'Unfortunately the user permanently blocked push. Please unblock / ' +
                        'allow them to switch on push notifications.');
                    break;
                case 'granted':
                    // Set the state of the push switch
                    console.log('case granted');
                    break;
                case 'prompt':
                    pushSwitch.checked = false;
                    console.log('case prompt');
                    break;
            }
        }

        function setUpPushPermission() {
            navigator.permissions.query({name: 'push', userVisibleOnly: true})
                .then(function(permissionStatus) {
                    // Set the initial state
                    permissionStatusChange(permissionStatus);

                    // Handle Permission State Changes
                    permissionStatus.onchange = function() {
                        permissionStatusChange(this);
                    };

                    // Check if push is supported and what the current state is
                    navigator.serviceWorker.ready.then(function(serviceWorkerRegistration) {
                        // Let's see if we have a subscription already
                        serviceWorkerRegistration.pushManager.getSubscription()
                            .then(function(subscription) {
                                if (!subscription) {
                                    // NOOP
                                    return;
                                }

                                console.log('update current state.');
                                // Update the current state with the
                                // subscriptionid and endpoint
                                onPushSubscription(subscription);
                            })
                            .catch(function(e) {
                                console.log('An error occured while calling getSubscription()', e);
                            });
                    });
                }).catch(function(err) {
                    console.log('Ooops Unable to check the permission',
                        'Unfortunately the permission for push notifications couldn\'t be ' +
                        'checked. Are you on Chrome 43+?');
                });
        }

        function setUpNotificationPermission() {
            console.log('setting notification setting');

            if (Notification.permission === 'default') {
                console.log('notification permissions === default');
                return;
            }

            // Check if push is supported and what the current state is
            navigator.serviceWorker.ready.then(function(serviceWorkerRegistration) {
                // Let's see if we have a subscription already
                serviceWorkerRegistration.pushManager.getSubscription()
                    .then(function(subscription) {
                        if (!subscription) {
                            // NOOP
                            console.log('not subscription');
                            return;
                        }

                        // Update the current state with the
                        // subscriptionid and endpoint
                        console.log('onpushsubscription should be entered');
                        onPushSubscription(subscription);
                    })
                    .catch(function(e) {
                        console.log('An error occured while calling getSubscription()', e);
                    });
            });
        }

        // Once the service worker is registered set the initial state
        function initialiseState() {
            // Check if notifications are supported
            if (!('showNotification' in ServiceWorkerRegistration.prototype)) {
                console.warn('Notifications aren\'t supported.');
                return;
            }
            // Check the current Notification permission.
            // If its denied, it's a permanent block until the
            // user changes the permission
            else if (Notification.permission === 'denied') {
                console.log('Ooops Notifications are Blocked',
                    'Unfortunately notifications are permanently blocked. Please unblock / ' +
                    'allow them to switch on push notifications.');
                return;
            }
            // Check if push messaging is supported
            else if (!('PushManager' in window)) {
                console.warn('Push messaging isn\'t supported.');
                return;
            }

            pushSwitch.disabled = false;
            // Is the Permissions API supported
            if ('permissions' in navigator) {
                console.log('setting push permissions');
                setUpPushPermission();
                return;
            } else {
                console.log('setting notification permissions');
                setUpNotificationPermission();
            }
        }

        var enablePushSwitch = $('.js-checkbox');

        var pushSwitch = document.getElementById('notifbox');
        pushSwitch.disabled = true;

        var ua = navigator.userAgent.toLowerCase();
        var isAndroid = ua.indexOf('android') > -1; //&& ua.indexOf("mobile");
        $scope.showNotif = isAndroid;

        if (!isAndroid) {
            // Do something!
            // Redirect to Android-site?
            pushSwitch.disabled = true;
            console.log('not android');
            return;
        }

        enablePushSwitch.change(function(e) {
            console.log('checkbox changed');
            if (e.target.checked) {
                console.log('subscribing device');
                subscribeDevice();
            } else {
                console.log('unsubscribing device');
                unsubscribeDevice();
            }
        });

        // Check that service workers are supported
        if ('serviceWorker' in navigator) {
            navigator.serviceWorker.register('service-worker.js')
                .then(initialiseState);
        } else {
            // disable button if serviceworker is not available
            // Service Workers aren't supported so you should hide the push UI
            // If it's currently visible.
            console.log('Ooops Service Workers aren\'t Supported',
                'Service Workers aren\'t supported in this browser. ' +
                'For this demo be sure to use ' +
                '<a href="https://www.google.co.uk/chrome/browser/canary.html">Chrome Canary</a>' +
                ' or version 42.');
        }
    });
