angular.module('flashy.StudyController', ['ui.router']).

    controller('StudyController', function($scope, $stateParams, $state, $http, UserService, Flashcard) {

        $('.datepicker').pickadate({
            selectMonths: true, // Creates a dropdown to control month
            selectYears: 15 // Creates a dropdown of 15 years to control year
        });

        $('select').material_select();

        // the "href" attribute of .modal-trigger must specify the modal ID that wants to be triggered
        $('.modal-trigger').leanModal({
                dismissible: true, // Modal can be dismissed by clicking outside of the modal
                opacity: .5, // Opacity of modal background
                in_duration: 300, // Transition in duration
                out_duration: 200, // Transition out duration
                ready: function() {
                    alert('Ready');
                }, // Callback for Modal open
                complete: function() {
                    alert('Closed');
                } // Callback for Modal close
            }
        );

        // Open by default
        $('#content-x').slideDown(250).addClass('open');
        $('#content-dateselection').slideDown(250).addClass('open');

        // JQuery range slider initialization
        /*
         $(function() {
         $( "#slider-range" ).slider({
         range: true,
         min: 0,
         max: 500,
         values: [ 75, 300 ],
         slide: function( event, ui ) {
         $( "#amount" ).val( "$" + ui.values[ 0 ] + " - $" + ui.values[ 1 ] );
         }
         });
         $( "#amount" ).val( "$" + $( "#slider-range" ).slider( "values", 0 ) +
         " - $" + $( "#slider-range" ).slider( "values", 1 ) );
         });
         */

        $('#start-date').val('2015-03-15');
        $('#end-date').val('2015-06-12');

        sectionId = $stateParams.sectionId;
        $scope.UserService = UserService;

        $scope.quiz = null; // The received FlashcardQuiz object.
        $scope.cardCount = 0; // Keeps track of cards in a study session.
        $scope.hasBlanks = true; // Whether current $scope.quiz has blanks.
        $scope.inResultsModal = false; // Whether user is @ results modal.
        $scope.inQuestionsModal = false; // Whether user is @ results modal.

        console.log('user sections', $scope.UserService.getUserData().sections);

        /* Sets current study class to the one passed in (y) */
        $scope.toggleSectionToStudy = function(id) {
            console.log('toggle sect', id);
            if ($scope.sectionToStudy == id) $scope.sectionToStudy = null;
            else $scope.sectionToStudy = id;
        };

        /* Opens or closes content collapsible */
        $scope.toggleContent = function(event, index) {
            if ($('#content-x').hasClass('open')) { // let's close it
                // Note: 250 is duration (ms) of animation
                $('#content-x').slideUp(250).removeClass('open');
            } else { // let's open it
                $('#content-x').slideDown(250).addClass('open');
            }
        };

        $scope.quizModalFetch = function() {
            $('#quizup--question').openModal();
            $('#answer').focus();
        };
        $scope.quizModalClose = function() {
            $('#quizup--question').closeModal();
        };

        $scope.resultModalFetch = function() {
            $('#quizup--result').openModal();
        };
        $scope.resultModalClose = function() {
            $('#quizup--result').closeModal();
        };

        /* Fetches the quiz to display to user
         * // TODO Hella work to be done, especially on dates regards!!!
         // FIXME e.g. date checks, eTC ETC the date range is supposed to be
         * 3/31 to 6/12/2015
         */
        $scope.quizState = 'fetching';
        $scope.fetchQuiz = function() {
            $scope.quizState = 'fetching';
            console.log('fetching quiz...');

            // Interpret chosen dates.
            //console.log('startdate:', new Date($('#start-date').val()+'T00:00:00Z'));
            //console.log('enddate:', $('#end-date').val() + 'T00:00:00Z');

            //TODO: datetime range check YO!!!


            var start = new Date($('#start-date').val());
            var end = new Date($('#end-date').val());

            console.log($('#start-date').val());
            console.log($('#end-date').val());
            //console.log($('#date-pick-start').val());
            //console.log($('data pick is ' + date-pick);
            // Time to get quiz...
            /*
             if ($('#start-date').val() == null || $('#end-date').val() == null) {
             studyRequest = {
             'sections': section
             };
             } else {
             studyRequest = {
             'sections': section,
             'material_date_begin': start,
             'material_date_end': end
             };
             }
             */

            studyRequest = {};
            if ($scope.sectionToStudy) studyRequest.sections = [$scope.sectionToStudy];
            $scope.busy = true;
            $http.post('/api/study/', studyRequest).
                success(function(data) {
                    console.log('Fetched card:', data);
                    $scope.quiz = data;
                    $scope.busy = false;
                    // If the card has no blanks
                    if (data.mask.length == 0) {
                        $scope.text0 = data.text;
                        $scope.text1 = '';
                        $scope.textblank = '';
                        $scope.hasBlanks = false;
                    } else { // Blank exists! :-)
                        $scope.text0 = data.text.slice(0, data.mask[0]);
                        $scope.text1 = data.text.slice(data.mask[1]);
                        $scope.textblank = data.text.slice(data.mask[0], data.mask[1]);
                        $scope.hasBlanks = true;
                    }

                    $scope.cardCount += 1;
                    $scope.answer = ''; // reset answer
                    $scope.inQuestionsModal = true;
                    $scope.quizModalFetch();
                    $scope.quizState = 'fetched';
                }).error(function(err) {
                    Materialize.toast("Can't study; there aren't any cards in your deck for the selected sections.", 4000);
                });
        };

        /* Transitions from the user input to the results modal */
        $scope.sendAnswer = function(ans) {
            $scope.busy = true;
            console.log('my answer', ans);
            //Answer sending

            if (ans != '') {
                if (ans.length > 255) {
                    ans = ans.substring(0, 255);
                    console.log('truncated answer', ans);
                }
                var quizAns = {
                    'pk': $scope.quiz.pk,
                    'response': ans
                };

                $http.patch('/api/study/' + $scope.quiz.pk, quizAns).
                    success(function(data) {
                        $scope.busy = false;
                        $scope.quizModalClose();
                        $scope.resultModalFetch();
                        $scope.inResultsModal = true;
                    });
                $scope.inQuestionsModal = false;
            } else {
                console.log('NO ANSWER, NO GO!');
            }
        };

        $scope.sendCorrectness = function(correctness) {
            var quizAns = {
                'pk': $scope.quiz.pk,
                'correct': correctness
            };
            $scope.busy = true;
            $http.patch('/api/study/' + $scope.quiz.pk, quizAns).
                success(function(data) {
                    console.log('Fetched card:', data);
                    $scope.resultModalClose();
                    $scope.fetchQuiz();
                    $scope.busy = false;
                    $scope.answer = ''; // reset answer
                }).error(function(err) {
                    console.log('Fetch Error');
                });
            $scope.inResultsModal = false;
        };

        $(document).keydown(function(e) {
            var keyed = e.which;
            if ($scope.inResultsModal) {
                if (keyed == 89) { // 'Y' keydown
                    $scope.sendCorrectness(true);
                } else if (keyed == 78) { // 'N' keydown
                    $scope.sendCorrectness(false);
                }
            }
            if ($scope.inQuestionsModal && !$scope.hasBlanks) {
                if (keyed == 13) { // 'enter' keydown
                    $scope.fetchQuiz();
                }
            }
        });


        /* OLD STUFF :in case you still neeed it */
        // Flashcard content
        $scope.htmlContent = 'sample text here longwordddddddddddddddddddddddddddd hello there from js review ctrl alwkejflakewjflk awjkefjkwefjlkea jfkewjaweajkakwef jk fjeawkafj kaewjf jawekfj akwejfk ';
        //single card
        $scope.samples =
        {
            'name': 'lol',
            'text': 'sample text here 111111 woo hoo I think it works',
            'mask': [[0, 6], [16, 23]]
        };

        // get text to display as array
        $scope.displayText = [];
        // get answers to blanks as array
        $scope.blankText = [];
        var start = 0; // where to start next string break
        for (var i = 0; i < $scope.samples.mask.length; i++) {
            $scope.displayText.push($scope.samples.text.substring(start, $scope.samples.mask[i][0]));
            $scope.blankText.push($scope.samples.text.substring($scope.samples.mask[i][0], $scope.samples.mask[i][1]));
            start = $scope.samples.mask[i][1];
        }
        if (start != $scope.samples.mask.length - 1)
            $scope.displayText.push($scope.samples.text.substring(start));

        // user entered responses as array
        $scope.blank = [];
    }
);
